function [] = plot_1D_example()

x = [5,7,20,36,44,56,70,80,90]';
y = 20 - 15 * sin(x / 10);
y = x * 0;

	m = length(x);

	p = 2;
	theta = .01;

	% Our kernel function
	correlation_fct = @(xi, xj) exp(-theta * sum(abs(xi - xj).^p));

	% Compute the correlation matrix
	C = zeros(m,m);
	for i = 1:m,
		for j = i+1:m,
			C(i,j) = feval(correlation_fct, x(i), x(j));
			C(j,i) = C(i,j);
		end
		C(i,i) = feval(correlation_fct, x(i), x(i));
	end
	C

	% Compute mu, sigma^2 and lambda
	invC = pinv(C);
	mu = 0;
	sig = 1;
%	mu = (ones(1,m) * invC * y) / (ones(1,m) * invC * ones(m,1))
%	sig = ((y - mu)' * invC * (y - mu)) / m
	lambda = (y - mu)' * invC;

	% Interpolate at interval [0,max(x)]
	xs = linspace(-20,120,200)';
	ys = zeros(1,200);
	for i = 1:200
		c = zeros(1,m);
		for j = 1:m,
			c(j) = feval(correlation_fct, xs(i), x(j));
		end
		ys(i) = mu + c * lambda';
		es(i) = sig * (1 - c * invC * c' + ((1 - ones(1,m) * invC * c')^2 / (ones(1,m) * invC * ones(m,1))));
	end

	clf
	plot(x, y, 'sk', 'MarkerSize', 8, 'MarkerFaceColor', 'k')
%	ylim([0 ceil(1.1 * max(y))])
	hold on
	plot(xs, ys, 'LineWidth', 2);
%	plot(xs, ys - sqrt(es), 'r', 'LineWidth', 2);
	plot(xs, ys + sqrt(es), 'r', 'LineWidth', 2);
	plot(x, y, 'sk', 'MarkerSize', 8, 'MarkerFaceColor', 'k')

	title('', 'FontSize', 14)
	legend('Datapoints', 'm (x | A)', 's (x | A)')
	xlabel('x', 'FontSize', 16)
	ylabel('s (x | A)', 'FontSize', 16)
	set(gca, 'FontSize', 12);
	grid on

	resolution = 600;
	print('-f', ['-r', num2str(resolution)], '-dpng', 'plot_1D_example.png');

end
